--- /dev/null	Wed Feb 14 00:45:56 2007
+++ squid/src/raid.c	Wed Feb 14 00:47:22 2007
@@ -0,0 +1,645 @@
+
+/*
+ * $Id: raid.c,v 1.1.2.1 2000/12/17 14:36:24 hno Exp $
+ *
+ * DEBUG: section 91     RAID support
+ * AUTHOR: Nikita Danilov <NikitaDanilov@Yahoo.COM>
+ * COPYRIGHT: This file is Copyright 2000 by Hans Reiser <Hans@Reiser.TO>
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by the
+ *  Regents of the University of California.  Please see the COPYRIGHT
+ *  file for full details.  Squid incorporates software developed
+ *  and/or copyrighted by other sources such as this file.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ * */
+
+/*
+
+  This is main part of squid sub-system through which one can
+  dynamically switch squid cache_dirs offline and back online.
+
+  The main and initial reason for this was support for the disk
+  hot-replacement (when supported by hardware), but this can be used
+  for any purpose.
+
+  OUTLINE:
+
+  (*) kernel or user notifies squid about cache directory state
+  change. This is done through signals. Such signal should came with
+  siginfo structure. Hence you cannot use kill. Simple utility ss (for
+  Send-signal, not Schutzstaffel) is provided for this purpose.
+
+  (*) from the value in siginfo struct, squid extracts number of
+  cache_dir (index in Config.cacheSwap.swapDirs) and direction of
+  status change (00 --- goes offline, 01 --- goes online).
+
+  (*) squid marks cache_dir offline, updates total number of online
+  caches and calls back-end specific callback (through function
+  pointer in _SwapDir.offline, _SwapDir.online). If all caches are
+  offline, squid dies miserably (this is not logically necessary: we
+  can in stead just serve all requests from network, but this will
+  require changes all over code, I guess).
+
+  (*) squid executes command, specified by new config option:
+  offline_notify_cmd or online_notify_cmd. This command is supplied
+  with 3 arguments: path of the cache_dir in question, its index and
+  device where it's mounted (as indicated by watch_failure
+  option). Reasonable command may send message to the operator and
+  umount drive.
+
+  (*) from this moment on, store dir selection functions
+  (storeDirSelectSwapDirLeastLoad() and
+  storeDirSelectSwapDirRoundRobin()) will skip offline cache and
+  Butterfly reselection will try to re-hash requests to different
+  directories.
+
+  HOT-REPLACEMENT:
+
+  This is mainly in raidInitListener(). It instructs kernel (by
+  issuing special ioctls) no notify Squid when SCSI drive dies.
+
+
+  There is also old errno-based error detection, described below. Per
+  dir errnos and thresholds were added.
+
+  ---------------- old outdated description ---------------------
+
+  Here is general outline:
+  [posted as <14822.56117.262849.688030@beta.namesys.com> in 
+   squidng@cacheboy.net]
+
+  * In struct _fde I have added backpointer to the swapdir this file
+  descriptor serves. This is currently only maintained for the butterfly
+  fds but this ought to be improved.
+
+  * All calls to read/write were replaced to the calls to
+  comm_(read|write)_wrapper (This is logical thing to do anyway,
+  right?).
+
+  * Wrappers call watchDiskDies(). These calls are done through some
+  callback mechanism, so anyone can dynamically add function(s) to be
+  called on each read or write.
+
+  * watchDiskDies() checks for some magic errno (I use ENXIO, but
+  ENODEV, ENOTSUP or ENOMEDIUM are possible candidates too.).
+
+  * If there were more than ERRORS_THRESHOLD errnos watchDiskDies()
+  declares drive dead (offline) and calls offlineSwapDir() taking swap
+  dir number from the fde.
+
+  * offlineSwapDir() just updates flags in swapdir. These flags are
+  taken into account by storeBfSelectSwapDir(), that chooses only
+  online dirs. Other backends should be updated too.
+
+  There are obvious deficiencies in this prototype: only global
+  counter of errnos is kept. Thus if there are two drives dying at the
+  same time we cannot distinguish their errnos. I am not sure this is
+  at all important. Also, there are insufficient provisions for
+  adequate debugging yet. Some way should be devised to force
+  reads/writes from certain device to return given errno. This can be
+  put into kernel (as special block device driver and I have seen
+  something about this on fsdevel list, or as patch for reiserfs) or
+  we can do this in the squid. This is simpler but we have then keep
+  track which device fd is attached to. I think this can be done as
+  special read/write-callback fired before watchDiskDies() and setting
+  errno. But how to control it? Signals are over-used already.  */
+
+/* TODO:
+
+   \begin{itemize}
+   \item proper debugging (in progress)
+   \item store information about online/offline state. Think squid 
+         crashes when some disks are offline and restarts. We would
+		 like to start without going through errnos for these disks 
+		 again
+   \item per drive errno counters (and settings: DISK_DIES_ERRNO and 
+         ERRORS_THRESHOLD)
+   \item install fde.swap_dir in backends other than butterfly
+   \item update cache_dir selection functions other than storeBfSelectSwapDir
+   \end{itemize}
+*/
+
+#include "squid.h"
+
+#if defined( DISK_REPL )
+
+#include <signal.h>
+
+#include <sys/types.h>
+#define CONFIG_SCSI_HOT_REPLACE
+#include <scsi/scsi.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <scsi/sg.h>
+
+#define DEBUG( format, args... )					\
+         debug( 91, 9 )( CURRENT_FUNCTION_NAME " (%s:%i): " format "\n",	\
+			__FILE__, __LINE__ , ##args )
+
+#define TRACE    DEBUG( "" )
+#define LOGERROR debug( 91, 3 )
+
+typedef enum { goOffline = 0, goOnline = 1, wrongEvent } CtrlEvent;
+
+static sig_atomic_t hasCtrlEvent = 0;
+static CtrlEvent ctrlEvent   = wrongEvent;
+static int       ctrlSwapDir = -1;
+
+void raidCtrl( int sigNum, siginfo_t *info, void *data );
+static char *getDeviceByCache( char *path );
+EVH doRaidCtrl;
+static void registerRaidCtrlEvent();
+
+static void notifyAboutOffline( SwapDir *dir );
+static void notifyAboutOnline( SwapDir *dir );
+static void notifyAboutStateSwitch( char *cmd, SwapDir *dir );
+
+int raidInit()
+{
+  struct sigaction act;
+
+  act.sa_sigaction = raidCtrl;
+  act.sa_flags     = SA_SIGINFO;
+  if( sigaction( RAID_CTRL_SIG, &act, NULL ) == 0 )
+    {
+      registerRaidCtrlEvent();
+    }
+  else
+    {
+      DEBUG( "sigaction failed: %s", xstrerror() );
+    }
+  addReadHook( watchDiskDies, NULL );
+  addWriteHook( watchDiskDies, NULL );
+  return 1;
+}
+
+void raidInitListener()
+{
+  wordlist *watcher;
+
+  for( watcher = Config.disk_repl_watch_list ;
+       watcher != NULL ; watcher = watcher -> next )
+    {
+      if( ( watcher -> key != NULL ) && 
+          ( watcher -> next != NULL ) && ( watcher -> next -> key != NULL ) )
+        {
+          int fd;
+
+          fd = open( watcher -> key, O_RDONLY );
+          if( fd != -1 )
+            {
+              struct SCSI_hot_replace repl;
+              char *path;
+              int   swap;
+          
+              repl.offline_code = ( int ) watcher;
+              repl.signo = RAID_CTRL_SIG;
+              repl.pid = getpid();
+              repl.sigval = -1;
+
+              path = watcher -> next -> key;
+              FOREACHSDINDEX( swap )
+                {
+                  if( !strcmp( INDEXSD( swap ) -> path, path ) )
+                    {
+                      if( swap > 0xff )
+                        {
+                          LOGERROR
+                            ( "raidInitListener: sorry, index too big: %i\n",
+                              swap );
+                        }
+                      else
+                        {
+                          repl.sigval = ( goOffline << 8 ) | swap;
+                        }
+                      break;
+                    }
+                }
+
+              if( repl.sigval != -1 )
+                {
+                  if( ioctl( fd, SCSI_IOCTL_ADD_FAILURE_NOTIFY, &repl ) != -1 )
+                    {
+                      DEBUG( "adding watcher: %s -> %s (%i)",
+                             watcher -> key, path, swap );
+                    }
+                  else
+                    {
+                      LOGERROR( "raidInitListener: ioctl: %s\n", xstrerror() );
+                    }
+                }
+              else
+                {
+                  LOGERROR
+                    ( "raidInitListener: cannot find swap_dir: %s\n", path );
+                }
+              close( fd );
+            }
+          else
+            {
+              LOGERROR( "raidInitListener: error opening %s: %s\n",
+                              watcher -> key, xstrerror() );
+            }
+        }
+      else
+        {
+          LOGERROR
+            ( "raidInitListener: wrong syntax of `watch_failure' field\n" );
+          break;
+        }
+      watcher = watcher -> next;
+    }
+}
+
+syscallcb_result watchDiskDies( syscall_type call,
+                                int fd, int *errNo,
+                                void *data )
+{
+  /*   DEBUG( "swap_dir: %i errno: %i (%i)", fd_table[ fd ].swap_dir, *errNo, errno ); */
+  if( fd_table[ fd ].swap_dir != -1 )
+    {
+      SwapDir *dir;
+
+      assert( ( 0 <= fd_table[ fd ].swap_dir ) &&
+              ( fd_table[ fd ].swap_dir < Config.cacheSwap.n_configured ) );
+      dir = INDEXSD( fd_table[ fd ].swap_dir );
+      if( ( *errNo != 0 ) &&
+          ( *errNo == dir -> raid.offline_errno ) &&
+          ( ++( dir -> raid.errnos_detected ) >= dir -> raid.errno_threshold ) )
+        {
+          debug( 91, 1 )( "Cache_dir %i is dying...\n", dir -> index );
+          offlineSwapDir( dir -> index );
+          dir -> raid.errnos_detected = 0;
+        }
+    }
+#if 0
+  else if( *errNo == DISK_DIES_ERRNO )
+    {
+      /* If a system drive (not a cache dir drive) dies, we are toast,
+         no hope of continuing without interrruption, so print an
+         informative message and bail out. -hans */
+      debug( 91, 1 )( "System drive died. Finis.\n" );
+      shut_down( 0 );
+      return SYSCALLCB_ABORT;
+    }
+#endif
+  return SYSCALLCB_CONTINUE;
+}
+
+int offlineSwapDir( int index )
+{
+  if( index < 0 )
+    {
+      LOGERROR( "offlineSwapDir: %i < 0\n", index );
+      return 0;
+    }
+  else if( index >= Config.cacheSwap.n_configured )
+    {
+      LOGERROR( "offlineSwapDir: %i >= %i\n", 
+                index, Config.cacheSwap.n_configured );
+      return 0;
+    }
+
+  TRACE;
+  if( INDEXSD( index ) -> flags.offline )
+    {
+      DEBUG( "%i already offline", index );
+      return 0;
+    }
+  ++Config.cacheSwap.n_offline;
+  if( Config.cacheSwap.n_offline >= Config.cacheSwap.n_configured )
+    {
+      debug( 91, 1 )( "Last drive dies. Fare thee well.\n" );
+      /* just to maintain invariant that n_offline is the number of
+         swapdirs with (offline == 1) */
+      --Config.cacheSwap.n_offline;
+      shut_down( 0 );
+    }
+  else
+    {
+      SwapDir *dir;
+
+      dir = INDEXSD( index );
+      dir -> flags.offline = 1;
+      dir -> log.close( dir );
+      chdir( "/" ); /* to get out of umount's way */
+      if( dir -> offline != NULL )
+        {
+          dir -> offline( dir );
+        }
+      debug( 91, 1 )( "Cache_dir %i turned offline...\n", index );
+      notifyAboutOffline( dir );
+    }
+  return 1;
+}
+
+int onlineSwapDir( int index )
+{
+  SwapDir *dir;
+
+  if( index < 0 )
+    {
+      LOGERROR( "onlineSwapDir: %i < 0\n", index );
+      return 0;
+    }
+  else if( index >= Config.cacheSwap.n_configured )
+    {
+      LOGERROR( "onlineSwapDir: %i >= %i\n", 
+                index, Config.cacheSwap.n_configured );
+      return 0;
+    }
+
+
+  DEBUG( "index: %i", index );
+  dir = INDEXSD( index );
+  if( !dir -> flags.offline )
+    {
+      DEBUG( "%i already online", index );
+      return 0;
+    }
+  if( ( dir -> online != NULL ) && dir -> online( dir ) )
+    {
+      char *device;
+
+      debug( 91, 1 )( "Cache_dir %i turned online...\n", index );
+      dir -> log.open( dir );
+      dir -> flags.offline = 0;
+      dir -> raid.errnos_detected = 0;
+      --Config.cacheSwap.n_offline;
+      notifyAboutOnline( dir );
+      device = getDeviceByCache( dir -> path );
+      if( device != NULL )
+        {
+          int fd;
+
+          fd = open( device, O_RDONLY );
+          if( fd != -1 )
+            {
+              struct SCSI_hot_replace repl;
+          
+              repl.offline_code = ( int ) device;
+              repl.signo = RAID_CTRL_SIG;
+              repl.pid = getpid();
+              repl.sigval = -1;
+              repl.sigval = ( goOffline << 8 ) | index;
+
+              if( ioctl( fd, SCSI_IOCTL_ADD_FAILURE_NOTIFY, &repl ) != -1 )
+                {
+                  DEBUG( "re-adding watcher: %s -> %s (%i)",
+                         device, dir -> path, index );
+                }
+              else
+                {
+                  LOGERROR( "raidInitListener: ioctl: %s\n", xstrerror() );
+                }
+              close( fd );
+            }
+          else
+            {
+              LOGERROR( "Cannot re-establish fault notification at %s:%s (%s)",
+                        dir -> path, device, xstrerror() );
+            }
+        }
+    }
+  else
+    {
+      debug( 91, 1 )( "Cannot turn online cache_dir %i...\n", index );
+    }
+  return 1;
+}
+
+syscallcb_result simulateCrash( syscall_type call, 
+                                int fd, int *errNo, void *data )
+{
+  SimulateCrashData *crash = ( SimulateCrashData * ) data;
+
+  /*   DEBUG( "fd: %i swap_dir: %i time: %li fireTime: %li", */
+  /* 	 fd, fd_table[ fd ].swap_dir, squid_curtime, crash -> crashTime ); */
+  if( ( fd_table[ fd ].swap_dir == crash -> swapDirNo ) &&
+      ( squid_curtime >= crash -> crashTime ) )
+    {
+      static int sparseLogging = 0;
+
+      *errNo = INDEXSD( crash -> swapDirNo ) -> raid.offline_errno;
+      ++sparseLogging;
+      if( !( sparseLogging & ( sparseLogging - 1 ) ) )
+        {
+          DEBUG( "And therefore I claim swap_dir %i have to be ruined (%i:%i)", 
+                 crash -> swapDirNo, sparseLogging, *errNo );
+        }
+    }
+  return SYSCALLCB_CONTINUE;
+}
+
+int findFirstOnlineSD()
+{
+  int i;
+
+  assert( Config.cacheSwap.n_configured > Config.cacheSwap.n_offline );
+
+  FOREACHSDINDEX( i )
+    {
+      if( !( INDEXSD( i ) -> flags.offline ) )
+        {
+          return i;
+        }
+    }
+  assert( 0 );
+  return 0;
+}
+
+void raidCtrl( int sigNum, siginfo_t *info, void *data )
+{
+  /* don't risk asserts from signal handler, Just for documentation. */
+  assert( 1 || ( sigNum == RAID_CTRL_SIG ) );
+  assert( 1 || ( info != NULL ) );
+  assert( 1 || ( info -> si_code == SI_QUEUE ) );
+
+  /* don't bother to queue events. */
+  if( hasCtrlEvent == 0 )
+    {
+      ++hasCtrlEvent;
+      ctrlEvent = info -> si_value.sival_int >> 8;
+      ctrlSwapDir = info -> si_value.sival_int & 0xff;
+    }
+}
+
+void doRaidCtrl( void *data )
+{
+  if( hasCtrlEvent )
+    {
+      DEBUG( "event: %i dir: %i", ctrlEvent, ctrlSwapDir );
+      switch( ctrlEvent )
+        {
+        case goOffline:
+          DEBUG( "offlineSwapDir" );
+          offlineSwapDir( ctrlSwapDir );
+          break;
+        case goOnline:
+          DEBUG( "onlineSwapDir" );
+          onlineSwapDir( ctrlSwapDir );
+          break;
+        default:
+          DEBUG( "Wrong RAID control request" );
+          break;
+        }
+      hasCtrlEvent = 0;
+    }
+  registerRaidCtrlEvent();
+}
+
+static void registerRaidCtrlEvent()
+{
+  eventAdd( "RAID control", doRaidCtrl, NULL, 1, 0 );
+}
+
+static void notifyAboutOffline( SwapDir *dir )
+{
+  assert( dir != NULL );
+
+  if( Config.offline_notify_cmd != NULL )
+    {
+      notifyAboutStateSwitch( Config.offline_notify_cmd, dir );
+    }
+}
+
+static void notifyAboutOnline( SwapDir *dir )
+{
+  assert( dir != NULL );
+
+  if( Config.online_notify_cmd != NULL )
+    {
+      notifyAboutStateSwitch( Config.online_notify_cmd, dir );
+    }
+}
+
+static char *getDeviceByCache( char *path )
+{
+  wordlist *watcher;
+
+  assert( path != NULL );
+
+  for( watcher = Config.disk_repl_watch_list ;  watcher != NULL ; 
+       watcher = watcher -> next )
+    {
+      if( ( watcher -> key != NULL ) && 
+          ( watcher -> next != NULL ) && ( watcher -> next -> key != NULL ) )
+        {
+          if( !strcmp( watcher -> next -> key, path ) )
+            {
+              return watcher -> key;
+            }
+        }
+      watcher = watcher -> next;
+    }
+  return NULL;
+}
+
+static void notifyAboutStateSwitch( char *cmd, SwapDir *dir )
+{
+  int len;
+  char *cmd_buf;
+  char *dev;
+  int ret;
+  
+  assert( cmd != NULL );
+  assert( dir != NULL );
+
+  dev = getDeviceByCache( dir -> path );
+  dev = ( dev == NULL ) ? "<unknown-device>" : dev;
+
+  len = strlen( cmd ) + strlen( dir -> path ) + 20 + strlen( dev );
+  cmd_buf = xmalloc( len );
+  
+  snprintf( cmd_buf, len, "%s %s %i %s", cmd, dir -> path, dir -> index, dev );
+  DEBUG( "about to execute `%s'", cmd_buf );
+  /* XXX system is insecure. Will replace to 
+     fork()/dup()/close()/exec() later. 
+     Famous last words. */  
+  if( ( ret = system( cmd_buf ) ) != 0 )
+    {
+      LOGERROR( "notifyAboutStateSwitch: cannot execute `%s': %i: %s", 
+                cmd_buf, ret, xstrerror() );
+    }
+  xfree( cmd_buf );
+}
+
+/* DISK_REPL */
+#endif
+
+/*
+ * $Log: raid.c,v $
+ * Revision 1.1.2.1  2000/12/17 14:36:24  hno
+ * Imported raid from squidng
+ *
+ * Revision 1.1.2.11  2000/12/15 18:48:21  nikitadanilov
+ * Re-install fault notification when cache goes back online. Don't monitor errnos beyond cache_dirs.
+ *
+ * Revision 1.1.2.10  2000/12/15 14:45:23  nikitadanilov
+ * Bug fixes in ciociosan: clear can_* flags on file close; corrected work with fd-bitmap etc.
+ *
+ * Revision 1.1.2.9  2000/12/07 16:47:36  nikitadanilov
+ * new code commented
+ *
+ * Revision 1.1.2.8  2000/11/24 20:41:48  nikitadanilov
+ * Execute command specified in squid.conf when drive goes offline
+ *
+ * Revision 1.1.2.7  2000/11/22 14:42:59  nikitadanilov
+ * generally improved
+ *
+ * Revision 1.1.2.6  2000/11/08 11:49:07  nikitadanilov
+ * Dynamic switching cache_dirs offline and back through signals
+ *
+ * Revision 1.1.2.5  2000/10/19 09:57:12  nikitadanilov
+ * Added manual online/offline switching through signals (Signals with siginfo, e.g., sent by sigqueue.).
+ *
+ * Revision 1.1.2.4  2000/10/17 19:28:47  nikitadanilov
+ * Switched to per-swapdir errno settings and counters. Fallback findFirstOnlineSD() added: used by storeBfSelectSwapDir()
+ *
+ * Revision 1.1.2.3  2000/10/17 12:13:42  nikitadanilov
+ * Comments added. Check for last drive death corrected.
+ *
+ * Revision 1.1.2.2  2000/10/13 15:43:18  nikitadanilov
+ * RAID disk replcement changes: added per-fs callbacks called on on/of-line switch; Crash simulation added; Code commented. It started to work (with crash simulation). Alpha release state reached.
+ *
+ */
+
+/*
+ * Make Linus happy.
+ * ---------------------------------------------------------------------------
+ * Local variables:
+ * c-indent-level: 4 
+ * c-brace-imaginary-offset: 0
+ * c-brace-offset: -4
+ * c-argdecl-indent: 4
+ * c-label-offset: -4
+ * c-continued-statement-offset: 4
+ * c-continued-brace-offset: 0
+ * indent-tabs-mode: nil
+ * tab-width: 8
+ * End:
+ */
+
Index: squid/src/squid.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/squid.h,v
retrieving revision 1.3.16.1.2.1.2.1
retrieving revision 1.3.16.1.2.1.2.1.2.1
diff -u -r1.3.16.1.2.1.2.1 -r1.3.16.1.2.1.2.1.2.1
--- squid/src/squid.h	17 Dec 2000 14:09:08 -0000	1.3.16.1.2.1.2.1
+++ squid/src/squid.h	17 Dec 2000 14:36:24 -0000	1.3.16.1.2.1.2.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: squid.h,v 1.3.16.1.2.1.2.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: squid.h,v 1.3.16.1.2.1.2.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -89,7 +89,13 @@
 #define assert(EX)  ((EX)?((void)0):xassert("EX", __FILE__, __LINE__))
 #endif
 
-#define LINGERING_CLOSE 1
+#define LINGERING_CLOSE 0
+
+#if defined( __GNUC__ )
+#define CURRENT_FUNCTION_NAME __PRETTY_FUNCTION__
+#else
+#define CURRENT_FUNCTION_NAME ""
+#endif
 
 /* 
    SIGIO-driven IO hack. Don't look here.
@@ -98,11 +104,6 @@
 /* #define TCP_ASYNC */
 #if defined( TCP_ASYNC )
 
-/* It's Butterfly's real name */
-#define SIGCIOCIOSAN ( SIGRTMIN + 8 )
-
-#define SIGINFO_PER_CALL 128
-
 /* this should be done before #include <fcntl.h>,
    because we need F_SETSIG. */
 #define _GNU_SOURCE
@@ -111,63 +112,11 @@
 #include <signal.h>
 #endif
 
-#if defined( __GNUC__ )
-#define CURRENT_FUNCTION_NAME __PRETTY_FUNCTION__
-#else
-#define CURRENT_FUNCTION_NAME __FUNC__
-#endif
-
-#define CLEAR_CAN_READ_INTERNAL( fd )									\
-	  debug( 90, 9 )( CURRENT_FUNCTION_NAME ": cleared can_read.\n" );	\
-	  fd_table[ fd ].flags.can_read = 0
-
-#define CLEAR_CAN_WRITE_INTERNAL( fd )									\
-	  debug( 90, 9 )( CURRENT_FUNCTION_NAME ": cleared can_write.\n" );	\
-	  fd_table[ fd ].flags.can_write = 0
-
-#define CLEAR_CAN_READ( fd ) do {							\
-      CLEAR_CAN_READ_INTERNAL( fd );						\
-      ++statCounter.syscalls.async.tail_reads; } while( 0 )
-
-#define CLEAR_CAN_WRITE( fd ) do {								\
-      CLEAR_CAN_WRITE_INTERNAL( fd );							\
-      ++statCounter.syscalls.async.tail_writes; } while( 0 )
-
-#define CLEAR_CAN_READ_IF_EMPTY( requestedSize, actuallyRead, fd )		\
-  do																	\
-    {																	\
-	  if( ( actuallyRead > 0 ) && ( actuallyRead < requestedSize ) )	\
-		{																\
-		  /* CLEAR_CAN_READ_INTERNAL( fd ); */							\
-          ++statCounter.syscalls.async.drain_reads;						\
-		}																\
-	}																	\
-  while( 0 )
-
-#define CLEAR_CAN_WRITE_IF_FULL( requestedSize, actuallyWritten, fd )		\
-  do																		\
-    {																		\
-	  if( ( actuallyWritten > 0 ) && ( actuallyWritten < requestedSize ) )	\
-		{																	\
-		  /* CLEAR_CAN_WRITE_INTERNAL( fd ); */								\
-          ++statCounter.syscalls.async.drain_writes;						\
-		}																	\
-	}																		\
-  while( 0 )
-
-#else
-
-#define CLEAR_CAN_READ( fd )  do {} while( 0 )
-#define CLEAR_CAN_WRITE( fd ) do {} while( 0 )
-#define CLEAR_CAN_READ_IF_EMPTY( requestedSize, actuallyRead, fd ) \
-  do {} while( 0 )
-#define CLEAR_CAN_WRITE_IF_FULL( requestedSize, actuallyWritten, fd )	\
-  do {} while( 0 )
-
 /* TCP_ASYNC */
 #endif
 
 
+
 #if HAVE_UNISTD_H
 #include <unistd.h>
 #endif
Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.3.16.1.4.1
retrieving revision 1.3.16.1.4.1.2.1
diff -u -r1.3.16.1.4.1 -r1.3.16.1.4.1.2.1
--- squid/src/ssl.c	17 Dec 2000 14:09:08 -0000	1.3.16.1.4.1
+++ squid/src/ssl.c	17 Dec 2000 14:36:24 -0000	1.3.16.1.4.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.3.16.1.4.1 2000/12/17 14:09:08 hno Exp $
+ * $Id: ssl.c,v 1.3.16.1.4.1.2.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -200,7 +200,7 @@
     read_sz = delayBytesWanted(sslState->delay_id, 1, read_sz);
 #endif
     statCounter.syscalls.sock.reads++;
-    len = read(fd, sslState->server.buf + sslState->server.len, read_sz);
+    len = comm_read_wrapper(fd, sslState->server.buf + sslState->server.len, read_sz);
     debug(26, 3) ("sslReadServer: FD %d, read   %d bytes\n", fd, len);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
@@ -210,7 +210,6 @@
 	kb_incr(&statCounter.server.all.kbytes_in, len);
 	kb_incr(&statCounter.server.other.kbytes_in, len);
 	sslState->server.len += len;
-	CLEAR_CAN_READ_IF_EMPTY( read_sz, len, fd );
     }
     cbdataLock(sslState);
     if (len < 0) {
@@ -219,7 +218,6 @@
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
     } else {
-      CLEAR_CAN_READ( fd );
       if (len == 0) {
 	comm_close(sslState->server.fd);
       }
@@ -240,7 +238,7 @@
 	fd, SQUID_TCP_SO_RCVBUF - sslState->client.len,
 	sslState->client.len);
     statCounter.syscalls.sock.reads++;
-    len = read(fd,
+    len = comm_read_wrapper(fd,
 	sslState->client.buf + sslState->client.len,
 	SQUID_TCP_SO_RCVBUF - sslState->client.len);
     debug(26, 3) ("sslReadClient: FD %d, read   %d bytes\n", fd, len);
@@ -248,8 +246,6 @@
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&statCounter.client_http.kbytes_in, len);
 	sslState->client.len += len;
-	CLEAR_CAN_READ_IF_EMPTY( SQUID_TCP_SO_RCVBUF - sslState->client.len,
-				 len, fd );
     }
     cbdataLock(sslState);
     if (len < 0) {
@@ -260,7 +256,6 @@
 #endif
 	if (ignoreErrno(errno))
 	  {
-	    CLEAR_CAN_READ( fd );
 	    level = 3;
 	  }
 	debug(50, level) ("sslReadClient: FD %d: read failure: %s\n",
@@ -285,7 +280,7 @@
     debug(26, 3) ("sslWriteServer: FD %d, %d bytes to write\n",
 	fd, sslState->client.len);
     statCounter.syscalls.sock.writes++;
-    len = write(fd,
+    len = comm_write_wrapper(fd,
 	sslState->client.buf,
 	sslState->client.len);
     debug(26, 3) ("sslWriteServer: FD %d, %d bytes written\n", fd, len);
@@ -294,7 +289,6 @@
 	kb_incr(&statCounter.server.all.kbytes_out, len);
 	kb_incr(&statCounter.server.other.kbytes_out, len);
 	assert(len <= sslState->client.len);
-	CLEAR_CAN_WRITE_IF_FULL( sslState->client.len, len, fd );
 	sslState->client.len -= len;
 	if (sslState->client.len > 0) {
 	    /* we didn't write the whole thing */
@@ -309,10 +303,6 @@
 	    ("sslWriteServer: FD %d: write failure: %s.\n", fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
-	else
-	  {
-	    CLEAR_CAN_WRITE( fd );
-	  }
     }
     if (cbdataValid(sslState))
 	sslSetSelect(sslState);
@@ -329,7 +319,7 @@
     debug(26, 3) ("sslWriteClient: FD %d, %d bytes to write\n",
 	fd, sslState->server.len);
     statCounter.syscalls.sock.writes++;
-    len = write(fd,
+    len = comm_write_wrapper(fd,
 	sslState->server.buf,
 	sslState->server.len);
     debug(26, 3) ("sslWriteClient: FD %d, %d bytes written\n", fd, len);
@@ -337,7 +327,6 @@
 	fd_bytes(fd, len, FD_WRITE);
 	kb_incr(&statCounter.client_http.kbytes_out, len);
 	assert(len <= sslState->server.len);
-	CLEAR_CAN_WRITE_IF_FULL( sslState->server.len, len, fd );
 	sslState->server.len -= len;
 	/* increment total object size */
 	if (sslState->size_ptr)
@@ -355,10 +344,6 @@
 	    ("sslWriteClient: FD %d: write failure: %s.\n", fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
-	else
-	  {
-	    CLEAR_CAN_WRITE( fd );
-	  }
     }
     if (cbdataValid(sslState))
 	sslSetSelect(sslState);
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.6.4.1.2.1
retrieving revision 1.6.4.1.2.1.4.1
diff -u -r1.6.4.1.2.1 -r1.6.4.1.2.1.4.1
--- squid/src/store.c	17 Dec 2000 13:55:39 -0000	1.6.4.1.2.1
+++ squid/src/store.c	17 Dec 2000 14:36:24 -0000	1.6.4.1.2.1.4.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.6.4.1.2.1 2000/12/17 13:55:39 hno Exp $
+ * $Id: store.c,v 1.6.4.1.2.1.4.1 2000/12/17 14:36:24 hno Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -780,7 +780,7 @@
     static time_t last_warn_time = 0;
 
     /* walk each fs */
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+    FOREACHSDINDEX( i ) {
 	/* call the maintain function .. */
 	SD = INDEXSD(i);
 	/* XXX FixMe: This should be done "in parallell" on the different
